(defun stamp_numpages ()
(setq ss (ssget "_X" '((2 . "sh*"))))

(setq fn (open (strcat (getvar "dwgprefix") "stamp.zvk") "r") yn 20)
	(if fn (progn
		(setq name (read-line fn))
		(setq shifr (read-line fn))
		(setq ShortType (read-line fn))
		(setq LongType (read-line fn))
	)(print "   !"))
(close fn)

(princ "\n    ?:")
(setq startpage (getint))
(if (zerop startpage)(setq startpage 1))
      
(if ss (progn
  	(setq pages (- (+ startpage (sslength ss)) 1))
	(setq page (- (+ startpage(sslength ss)) 1))
	(while (setq sn (ssname ss 0))

		(setq el1 (entget sn) bn1 (cdr(assoc 2 el1)))
	  	(setq pt (cdr(assoc 10 el1)))
	  	(setq x0 (nth 0 pt))	
	  	(setq y0 (nth 1 pt))
	  	;    -  
	  	(setq xb_n1 (- x0 0.0))
		(setq yb_n1 (+ y0 40.0))
	  	(setq xb_n2 (- xb_n1 120.0))
		(setq yb_n2 (+ yb_n1 15.0))
		;   -  
	  	(setq xb_i1 (- x0 50.0))
		(setq yb_i1 (+ y0 15.0))
	  	(setq xb_i2 (- xb_i1 70.0))
		(setq yb_i2 (+ yb_i1 25.0))
		;   -  
	  	(setq xb_p1 (- x0 30.0))
		(setq yb_p1 (+ y0 15.0))
	  	(setq xb_p2 (- xb_p1 8.0))
		(setq yb_p2 (+ yb_p1 5.0))
		;    -  
	  	(setq xb_ps1 (- x0 0.0))
		(setq yb_ps1 (+ y0 15.0))
	  	(setq xb_ps2 (- xb_ps1 15.0))
		(setq yb_ps2 (+ yb_ps1 5.0))
	  	;    -  
	  	(setq xl_n1 (- x0 10.0))
		(setq yl_n1 (+ y0 0.0))
	  	(setq xl_n2 (- xl_n1 110.0))
		(setq yl_n2 (+ yl_n1 15.0))
	  	;   -  
	  	(setq xl_p1 (- x0 0.0))
		(setq yl_p1 (+ y0 0.0))
	  	(setq xl_p2 (- xl_p1 10.0))
		(setq yl_p2 (+ yl_p1 10.0))
	  	
  		; 
	  	(if (member bn1 '("shbig" "SHBIG")) (setq smt (ssget "_C" (list xb_n1 yb_n1) (list xb_n2 yb_n2))))
	  	(if (member bn1 '("shlit" "SHLIT")) (setq smt (ssget "_C" (list xl_n1 yl_n1) (list xl_n2 yl_n2))))
	  
	  	(if smt (progn
		    (while (setq dmt (ssname smt 0))
			(setq el2 (entget dmt) bn2 (cdr(assoc 0 el2)))

		  	(if (member bn1 '("shbig" "SHBIG"))(Progn 
				(if (= bn2 "MTEXT")(entdel dmt))))
			(if (member bn1 '("shlit" "SHLIT"))(Progn 
				(if (= bn2 "MTEXT")(entdel dmt))))					   
	                (ssdel dmt smt)
		     )
		)(progn
		))
		(if (member bn1 '("shbig" "SHBIG")) (command "_mtext" (list xb_n1 yb_n1) "_s" "gost 2.304" "_j" "_mc" (list xb_n2 yb_n2) (strcat shifr "-" ShortType) ""))	
		(if (member bn1 '("shlit" "SHLIT")) (command "_mtext" (list xl_n1 yl_n1) "_s" "gost 2.304" "_j" "_mc" (list xl_n2 yl_n2) (strcat shifr "-" ShortType) ""))	  	
		(setq smt nil)

	  	; 
	  	(if (member bn1 '("shbig" "SHBIG")) (setq smt (ssget "_C" (list xb_i1 yb_i1) (list xb_i2 yb_i2))))

	  	(if smt (progn
	  	   (while (setq dmt (ssname smt 0))
			(setq el2 (entget dmt) bn2 (cdr(assoc 0 el2)))

		  	(if (member bn1 '("shbig" "SHBIG"))(Progn 
				(if (= bn2 "MTEXT")(entdel dmt))
			))					   
		   (ssdel dmt smt)
		   )
		))
	  	(if (member bn1 '("shbig" "SHBIG"))(command "_mtext" (list xb_i1 yb_i1) "_s" "gost 2.304" "_j" "_mc" (list xb_i2 yb_i2) name LongType ""))
		(setq smt nil)
	  	; 
	  	(if (member bn1 '("shbig" "SHBIG")) (setq smt (ssget "_C" (list xb_p1 yb_p1) (list xb_p2 yb_p2))))
	  	(if (member bn1 '("shlit" "SHLIT")) (setq smt (ssget "_C" (list xl_p1 yl_p1) (list xl_p2 yl_p2))))
	  
	  	(if smt (progn
		    (while (setq dmt (ssname smt 0))
			(setq el2 (entget dmt) bn2 (cdr(assoc 0 el2)))

		  	(if (member bn1 '("shbig" "SHBIG"))(Progn 
				(if (= bn2 "MTEXT")(entdel dmt))))
			(if (member bn1 '("shlit" "SHLIT"))(Progn 
				(if (= bn2 "MTEXT")(entdel dmt))))					   
		    (ssdel dmt smt)
		    )
		))
		(if (member bn1 '("shbig" "SHBIG")) (command "_mtext" (list xb_p1 yb_p1) "_s" "gost 2.304" "_j" "_mc" (list xb_p2 yb_p2) page ""))	
		(if (member bn1 '("shlit" "SHLIT")) (command "_mtext" (list xl_p1 yl_p1) "_s" "gost 2.304" "_j" "_mc" (list xl_p2 yl_p2) page ""))	  
		(setq smt nil)
	  	; 
	  	(if (member bn1 '("shbig" "SHBIG")) (setq smt (ssget "_C" (list xb_ps1 yb_ps1) (list xb_ps2 yb_ps2))))

	  	(if smt (progn
	  	   (while (setq dmt (ssname smt 0))
			(setq el2 (entget dmt) bn2 (cdr(assoc 0 el2)))

		  	(if (member bn1 '("shbig" "SHBIG"))(Progn 
				(if (= bn2 "MTEXT")(entdel dmt))
			))					   
		   (ssdel dmt smt)
		   )
		))
	  	(if (member bn1 '("shbig" "SHBIG"))(command "_mtext" (list xb_ps1 yb_ps1) "_s" "gost 2.304" "_j" "_mc" (list xb_ps2 yb_ps2) pages ""))
	  	;___________________________________________
	  	(setq page (- page 1))
	  	(ssdel sn ss)
	  )
)
)
)

(defun stamp ()
(setq ss nil)
(setq fn (open (strcat (getvar "dwgprefix") "stamp.zvk") "r") yn 20)
	(if fn (progn
		(setq name (read-line fn))
		(setq shifr (read-line fn))
		(setq ShortType (read-line fn))
		(setq LongType (read-line fn))		
		(close fn)
		(vl-file-delete (strcat (getvar "dwgprefix") "stamp.zvk"))
		(setq ss (ssget "_X" '((2 . "sh*"))))
	))

(if ss (progn
(command "_zoom" "_a")
  	(setq pages (sslength ss))
	(setq page (sslength ss))
	(while (setq sn (ssname ss 0))

		(setq el1 (entget sn) bn1 (cdr(assoc 2 el1)))
	  	(setq pt (cdr(assoc 10 el1)))
	  	(setq x0 (nth 0 pt))	
	  	(setq y0 (nth 1 pt))
	  	;    -  
	  	(setq xb_n1 (- x0 0.0))
		(setq yb_n1 (+ y0 40.0))
	  	(setq xb_n2 (- xb_n1 120.0))
		(setq yb_n2 (+ yb_n1 15.0))
		;   -  
	  	(setq xb_i1 (- x0 50.0))
		(setq yb_i1 (+ y0 15.0))
	  	(setq xb_i2 (- xb_i1 70.0))
		(setq yb_i2 (+ yb_i1 25.0))
	  	;    -  
	  	(setq xl_n1 (- x0 10.0))
		(setq yl_n1 (+ y0 0.0))
	  	(setq xl_n2 (- xl_n1 110.0))
		(setq yl_n2 (+ yl_n1 15.0))
	  	
  		; 
	  	(if (member bn1 '("shbig" "SHBIG")) (setq smt (ssget "_C" (list xb_n1 yb_n1) (list xb_n2 yb_n2))))
	  	(if (member bn1 '("shlit" "SHLIT")) (setq smt (ssget "_C" (list xl_n1 yl_n1) (list xl_n2 yl_n2))))
	  
	  	(if smt (progn
		    (while (setq dmt (ssname smt 0))
			(setq el2 (entget dmt) bn2 (cdr(assoc 0 el2)))

		  	(if (member bn1 '("shbig" "SHBIG"))(Progn 
				(if (member bn2 '("MTEXT" "TEXT"))(entdel dmt))))
			(if (member bn1 '("shlit" "SHLIT"))(Progn 
				(if (member bn2 '("MTEXT" "TEXT"))(entdel dmt))))					   
	                (ssdel dmt smt)
		     )
		)(progn
		))
		(if (member bn1 '("shbig" "SHBIG")) (command "_mtext" (list xb_n1 yb_n1) "_s" "gost 2.304" "_h" 4 "_j" "_mc" (list xb_n2 yb_n2) (strcat shifr " " ShortType) ""))	
		(if (member bn1 '("shlit" "SHLIT")) (command "_mtext" (list xl_n1 yl_n1) "_s" "gost 2.304" "_h" 4 "_j" "_mc" (list xl_n2 yl_n2) (strcat shifr " " ShortType) ""))	  	
		(setq smt nil)

	  	; 
	  	(if (member bn1 '("shbig" "SHBIG")) (setq smt (ssget "_C" (list xb_i1 yb_i1) (list xb_i2 yb_i2))))

	  	(if smt (progn
	  	   (while (setq dmt (ssname smt 0))
			(setq el2 (entget dmt) bn2 (cdr(assoc 0 el2)))

		  	(if (member bn1 '("shbig" "SHBIG"))(Progn 
				(if (member bn2 '("MTEXT" "TEXT"))(entdel dmt))
			))					   
		   (ssdel dmt smt)
		   )
		))
	  	(if (member bn1 '("shbig" "SHBIG"))(command "_mtext" (list xb_i1 yb_i1) "_s" "gost 2.304" "_j" "_mc" (list xb_i2 yb_i2) name LongType ""))
		(setq smt nil)
	  	;___________________________________________
	  	(setq page (- page 1))
	  	(ssdel sn ss)
	  )
)
)
)
(defun stamp_V ()
(setq ss nil)
		(setq ss (ssget "_X" '((2 . "FA*"))))
	(command "_style" "eskd" "txt" 0 0.73 0 "" "" "")
(if ss (progn
(command "_zoom" "_a")
	(while (setq sn (ssname ss 0))

		(setq el1 (entget sn) bn1 (cdr(assoc 2 el1)))
	  	(setq pt (cdr(assoc 10 el1)) namf (strcase(cdr(assoc 2 el1))))
	  	(setq x0 (nth 0 pt))	
	  	(setq y0 (nth 1 pt))
	  	;   
	  	(setq xb_n1 (+ x0 20.0))
		(setq yb_n1 (cond
		((= namf "FA3NV") (+ y0 415))((= (substr namf 1 3) "FA3") (+ y0 292))
		((= (substr namf 1 3) "FA1") (+ y0 585))((= (substr namf 1 3) "FA2") (+ y0 415))((= (substr namf 1 3) "FA4") (+ y0 292))(t -10001)
		))

	  	(setq xb_n2 (+ xb_n1 70.0))
		(setq yb_n2 (- yb_n1 14.0))

 		; 
	  	(setq smt (ssget "_W" (list xb_n1 yb_n1) (list xb_n2 yb_n2)))
	  
	  	(if smt (command "_erase" smt ""))
		(if (> yb_n1 -10000)(progn
		(command "_TEXT" "_c" (list (+ xb_n1 35) (- yb_n1 7)) 4 -180 (strcat shifr " " ShortType))
;		(command "_mtext" (list xb_n1 yb_n1) "_s" "eskd" "_H" 4.0 "_j" "_mc" (list xb_n2 yb_n2) (strcat shifr " " ShortType) "")	
		(command "_rectang" (list xb_n1 yb_n1)(list xb_n2 yb_n2))	
		))

	  	;___________________________________________
	  	(ssdel sn ss)
	  )
)
)
	(command "_style" "eskd" "txt" 2.5 0.73 0 "" "" "")
)


(defun numpages ()
(setq ss (ssget "_X" '((2 . "sh*"))))

(princ "\n    ?:")
(setq startpage (getint))
(if (zerop startpage)(setq startpage 1))
      
(if ss (progn
  	(setq pages (- (+ startpage (sslength ss)) 1))
	(setq page (- (+ startpage(sslength ss)) 1))
	(while (setq sn (ssname ss 0))

		(setq el1 (entget sn) bn1 (cdr(assoc 2 el1)))
	  	(setq pt (cdr(assoc 10 el1)))
	  	(setq x0 (nth 0 pt))	
	  	(setq y0 (nth 1 pt))
		;   -  
	  	(setq xb_p1 (- x0 30.0))
		(setq yb_p1 (+ y0 15.0))
	  	(setq xb_p2 (- xb_p1 8.0))
		(setq yb_p2 (+ yb_p1 5.0))
		;    -  
	  	(setq xb_ps1 (- x0 0.0))
		(setq yb_ps1 (+ y0 15.0))
	  	(setq xb_ps2 (- xb_ps1 15.0))
		(setq yb_ps2 (+ yb_ps1 5.0))
	  	;   -  
	  	(setq xl_p1 (- x0 0.0))
		(setq yl_p1 (+ y0 0.0))
	  	(setq xl_p2 (- xl_p1 10.0))
		(setq yl_p2 (+ yl_p1 10.0))
	  	
	  	; 
	  	(if (member bn1 '("shbig" "SHBIG")) (setq smt (ssget "_C" (list xb_p1 yb_p1) (list xb_p2 yb_p2))))
	  	(if (member bn1 '("shlit" "SHLIT")) (setq smt (ssget "_C" (list xl_p1 yl_p1) (list xl_p2 yl_p2))))
	  
	  	(if smt (progn
		    (while (setq dmt (ssname smt 0))
			(setq el2 (entget dmt) bn2 (cdr(assoc 0 el2)))

		  	(if (member bn1 '("shbig" "SHBIG"))(Progn 
				(if (= bn2 "MTEXT")(entdel dmt))))
			(if (member bn1 '("shlit" "SHLIT"))(Progn 
				(if (= bn2 "MTEXT")(entdel dmt))))					   
		    (ssdel dmt smt)
		    )
		))
		(if (member bn1 '("shbig" "SHBIG")) (command "_mtext" (list xb_p1 yb_p1) "_s" "gost 2.304" "_j" "_mc" (list xb_p2 yb_p2) page ""))	
		(if (member bn1 '("shlit" "SHLIT")) (command "_mtext" (list xl_p1 yl_p1) "_s" "gost 2.304" "_j" "_mc" (list xl_p2 yl_p2) page ""))	  
		(setq smt nil)
	  	; 
	  	(if (member bn1 '("shbig" "SHBIG")) (setq smt (ssget "_C" (list xb_ps1 yb_ps1) (list xb_ps2 yb_ps2))))

	  	(if smt (progn
	  	   (while (setq dmt (ssname smt 0))
			(setq el2 (entget dmt) bn2 (cdr(assoc 0 el2)))

		  	(if (member bn1 '("shbig" "SHBIG"))(Progn 
				(if (= bn2 "MTEXT")(entdel dmt))
			))					   
		   (ssdel dmt smt)
		   )
		))
	  	(if (member bn1 '("shbig" "SHBIG"))(command "_mtext" (list xb_ps1 yb_ps1) "_s" "gost 2.304" "_j" "_mc" (list xb_ps2 yb_ps2) pages ""))
	  	;___________________________________________
	  	(setq page (- page 1))
	  	(ssdel sn ss)
	  )
)
)
)
