(vl-load-com)
(setq acadObject (vlax-get-acad-object))
(setq acadDocument (vla-get-ActiveDocument acadObject))
(setq mSpace (vla-get-ModelSpace acadDocument))
;(setq ename-circle (car (entsel "\nPick a Circle:")))
;(setq vlaobject-circle (vlax-ename->vla-object ename-circle))
(defun table1 ()
(setq column    3    ; . 
      line    10    ; . 
      tbl     (vla-addtable
                (vla-get-modelspace(vla-get-activedocument (vlax-get-acad-object)))
                 (vlax-3d-point (getpoint "\n   : "))
               line
                 column 
               8      ;   
                 75     ;    (,  )
                ) ;/ vla-addtable
) ;/ setq


)
(vl-load-com)
(defun c:Example_BreakHeight()
    ;; This example creates a table object and then breaks it into
    ;; two tables.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))

    ;; Create a new table objetc in model space
    (setq pt (vlax-3d-point 0 0 0))
  
    (setq modelSpace (vla-get-ModelSpace doc))
    (setq table (vla-Addtable modelSpace pt 30 5 10 30))

    (vla-put-EnableBreak table :vlax-true)
    (vla-put-BreakSpacing table 3.5)
    (vla-put-TableBreakHeight table 35.0)
    (vla-put-AllowManualHeights table :vlax-true)
    (vla-SetBreakHeight table 0 70.0)
    (vla-SetBreakHeight table 1 85.0)
    (vla-SetBreakHeight table 2 85.0)
    (vla-SetBreakHeight table 3 85.0)
    (vla-SetBreakHeight table 4 85.0)
    (vla-SetBreakHeight table 5 85.0)
    (vla-SetBreakHeight table 6 85.0)
    (vla-SetBreakHeight table 7 85.0)
    (vla-SetBreakHeight table 8 85.0)

    (vla-ZoomExtents acadObj)
)

(vl-load-com)
(defun c:Example_ContentChange()
    ;; This example adds a table in model space
    ;; and manipulates its contents
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))
    
    ;; Note: One content is created for each cell by default;
    ;; this function need to be called only to create additional contents.
    
    (setq pt (vlax-3d-point 0 0 0))
    
    ;; Creates arbitrary cell points to check
    (setq row 2
          col 2)
    
    ;; Creates the table with an arbitrary number of cells
    (setq modelSpace (vla-get-ModelSpace doc))   
    (setq MyTable (vla-AddTable modelSpace pt 5 5 10 30))
    (vla-SetTextHeight MyTable (+ acDataRow acHeaderRow acTitleRow) 1)
  
    (vla-Regen doc :vlax-true)
    (vla-ZoomExtents acadObj)

    (if (= (vla-IsEmpty MyTable row col) :vlax-true)
        (if (= (vla-IsContentEditable MyTable row col) :vlax-true)
            (alert "There is no content in the cell, but it is editable")
        )
    )

    ;; Create some content in an arbitrary cell
    (setq sID1 (vla-CreateContent MyTable row col 0))
    (setq sID2 (vla-CreateContent MyTable row col 1))
    (vla-SetTextString MyTable row col sID1 "Value1")
    (vla-SetTextString MyTable row col sID2 "Value2")
    (vla-Regen doc :vlax-true)
  
    (alert (strcat "The content IDs are "
		   "\nValue1: " (itoa sID1)
		   "\nValue2: " (itoa sID2)))
 
    ;; Move the content to another index
    (vla-MoveContent MyTable row col sID2 sID1)
    (vla-Regen doc :vlax-true)
    (alert "Content order changed")
  
    ;  Check that the content has been deleted
    (vla-DeleteContent MyTable row col)
    (vla-Regen doc :vlax-true)
    
    (if (= (vla-IsEmpty MyTable row col) :vlax-true)
        (if (= (vla-IsContentEditable MyTable row col) :vlax-true)
            (alert "There is no content in the cell, but it is editable")
        )
    )
)

(vl-load-com)
(defun c:Example_CellManipulation()
    ;; This example adds a table in model space and sets and gets a column name
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))

    (setq pt (vlax-3d-point 0 0 0))
  
    (setq modelSpace (vla-get-ModelSpace doc))
    (setq MyTable (vla-AddTable modelSpace pt 5 5 10 30))
    
    (vla-SetCellDataType MyTable 2 2 acLong acUnitDistance)
    (vla-SetCellFormat MyTable 1 3 "testFormat")
    (vla-SetCellState MyTable 4 3 acCellStateContentLocked)
    (vla-SetCellValue MyTable 1 4 5)
    
    (alert (strcat (itoa (vlax-variant-value (vla-GetCellValue MyTable 1 4))) " is the test cell's value."))

    (vla-ZoomExtents acadObj)
)

(defun C:demo-tablo()
(vl-load-com)
;;   
(setq tabelle_ueberschrift (list " 1"
" 2"
" 3"
" 4"
)
)
;   :
;;; (setq tabellen_liste
;;; (list (list "1.1" "2.1" "3.1" "4.1")
;;; (list "1.2" "2.2" "3.2" "4.2")
;;; (list "1.3" "2.3" "3.4" "4.3")
;;; (list "1.4" "2.4" "3.5" "4.4")
;;; )
;;; )

;    :
(setq tabellen_liste
(list (list "1.1" "1.2" "1.3" "1.4")
(list "2.1" "2.2" "2.3" "2.4")
(list "3.1" "3.2" "3.3" "3.4")
(list "4.1" "4.2" "4.3" "4.4")
)
)
;;   
(setq vlaxchen_tabelle
(vla-addtable
;;   
(vla-get-modelspace (vla-get-activedocument 
(vlax-get-acad-object)))
;;  
(vlax-3d-point (list 0 0 0))
;;  
(+ (length tabellen_liste) 2)
;;  
(length tabelle_ueberschrift)
;;  
500.0
;;  
3000.0
)
)
;;   
(vla-settext vlaxchen_tabelle 0 0 " ")
;;   
(vla-setcellalignment vlaxchen_tabelle 0 0 acmiddlecenter);0 0
;;    
(vla-setcelltextheight vlaxchen_tabelle 0 0 300.);5
;;   
(setq spalte 0)
(foreach item tabelle_ueberschrift
;;  
(vla-settext vlaxchen_tabelle 1 spalte item)
;; 
(vla-setcellalignment vlaxchen_tabelle 1 spalte acmiddlecenter)
;;  
(vla-setcelltextheight vlaxchen_tabelle 1 spalte 250.)
;;  
(setq spalte (1+ spalte))
)
;;   2-  ( -  -  )
(setq zeile 2);2
;;  
(setq spalte 0)
;;   
(foreach zeilen tabellen_liste
;;  :
(foreach item zeilen
;;  
(vla-settext vlaxchen_tabelle zeile spalte item)
;; 
(vla-setcellalignment vlaxchen_tabelle zeile spalte 
acmiddlecenter)
;;  
(vla-setcelltextheight vlaxchen_tabelle zeile spalte 250.);1.65
;;  
(setq spalte (1+ spalte))
)
;;  
(setq zeile (1+ zeile))
;;  
(setq spalte 0)
)

(princ)
)

(defun tabl_per()
	(setq ss (ssget "_X" '((8 . "DOCLAY0"))))
	(if ss (alert "          ")(tabl_per1))
)
(defun tabl_per1()
   (setq olderr *error* *error* attrerr)
(setvar "cmdecho" 0)   (setvar "HIGHLIGHT" 0)
   (dellay  "DocLay0")
   (command "_LAYER" "_M" "DocLay0" "")
;   (setvar "regenmode" 0)
	(sty_hi 0)
;   (setvar "REGENMODE" 1)
(setq osmode1 (getvar "osmode"))(setvar "osmode" 0)
;	(command "_style" "eskd" "gost_A.ttf" 0 0.8 15 "" "")
	(command "_zoom" "_w" '(210 0) '(3260 600))
	(setq nf 1 xt 0 yt 292 ln 0 zag nil nnf nil)
	(setq fn (open (strcat (getvar "dwgprefix") "tmp1.zvk") "r"))
	(if fn (progn
	(command "_insert" "doc1" (list 0 0) "" "" "")
	(command "_insert" "fa4n" (list 0 0) "" "" "")
	(command "_insert" "shbig" (list 205 5) "" "" "")
	(setq nstr (atoi (read-line fn)) nstr (+ nstr 1))
(vl-load-com)
(setq acadObject (vlax-get-acad-object))
(setq acadDocument (vla-get-ActiveDocument acadObject))
(setq mSpace (vla-get-ModelSpace acadDocument))
(setq 
      tbl     (vla-addtable
                (vla-get-modelspace(vla-get-activedocument (vlax-get-acad-object)))
                 (vlax-3d-point (list 20 277 0))
               (+ nstr 0) 4 
               8      ;   
                 45     ;    (,  )
                ) ;/ vla-addtable
)
(vla-DeleteRows tbl 0 1)
(vla-SetColumnWidth tbl 0 20)
(vla-SetColumnWidth tbl 1 110)
(vla-SetColumnWidth tbl 2 10)
(vla-SetColumnWidth tbl 3 45)
;		(vla-setcellalignment tbl 0 0 acmiddlecenter)
;		(vla-setcelltextheight tbl 0 0 3.5)
;		(vla-settext tbl 0 0 "..")
;		(vla-setcellalignment tbl 0 1 acmiddlecenter)
;		(vla-setcelltextheight tbl 0 1 3.5)
;		(vla-settext tbl 0 1 "")
;		(vla-setcellalignment tbl 0 2 acmiddlecenter)
;		(vla-setcelltextheight tbl 0 2 3.5)
;		(vla-settext tbl 0 2 ".")
;		(vla-setcellalignment tbl 0 3 acmiddlecenter)
;		(vla-setcelltextheight tbl 0 3 3.5)
;		(vla-settext tbl 0 3 "")
	(setq nstr1 0)
	(repeat (- nstr 1)
	  (setq str1 (print(read-line fn)))
		(if (= str1 "*")(setq str1 ""))
		(vla-setcellalignment tbl nstr1 0 acmiddlecenter)
		(vla-setcelltextheight tbl nstr1 0 2.5)
		(vla-setcelltextstyle tbl nstr1 0 "ESKD")
		(vla-settext tbl nstr1 0 str1)
	  (setq str2 (print(read-line fn)))
		(vla-setcellalignment tbl nstr1 1 acmiddlecenter)
		(vla-setcelltextheight tbl nstr1 1 2.5)
		(vla-setcelltextstyle tbl nstr1 1 "ESKD")
		(vla-settext tbl nstr1 1 str2)
	  (setq str3 (read-line fn))
		(vla-setcellalignment tbl nstr1 2 acmiddlecenter)
		(vla-setcelltextheight tbl nstr1 2 2.5)
		(vla-setcelltextstyle tbl nstr1 2 "ESKD")
		(vla-settext tbl nstr1 2 str3)
	  (setq str4 (read-line fn))
		(vla-setcellalignment tbl nstr1 3 acmiddlecenter)
		(vla-setcelltextheight tbl nstr1 3 2.5)
		(vla-setcelltextstyle tbl nstr1 3 "ESKD")
		(vla-settext tbl nstr1 3 str4)
	(setq nstr1 (1+ nstr1)))
	))(close fn)
    (vla-put-EnableBreak tbl :vlax-true)
    (vla-put-BreakSpacing tbl 25)
    (vla-put-TableBreakHeight tbl 215.0)
    (vla-put-AllowManualHeights tbl :vlax-true)
    (vla-SetBreakHeight tbl 0 215.0)
    (vla-SetBreakHeight tbl 1 255.0)
    (vla-SetBreakHeight tbl 2 255.0)
	(setq nfo (fix(/ (nth 0 (getvar "extmax")) 210)))
	(if (= nfo 1)(command "_text" (list (+ xt 168 25) 21.5) 2.5 0 "1")
	  (progn
	    (command "_text" (list (+ xt 168) 21.5) 3.5 0 "1")
	    (command "_text" (list (+ xt 168 25) 21.5) 3.5 0 (itoa nfo))
	    (setq i 2 xt (+ xt 210))
	    (repeat (- nfo 1)
		(command "_insert" "doc2" (list xt 0) "" "" "")
		(command "_insert" "fa4n" (list xt 0) "" "" "")
		(command "_insert" "shlit" (list (+ xt 205) 5) "" "" "")
		(command "_text" (list (+ xt 199) 9) 3.5 0 (itoa i))
	    (setq i (1+ i) xt (+ xt 210))
	    )
	))
   (setvar "HIGHLIGHT" 1)
   (command "_LAYER" "_M" "0" "")
	(command "_zoom" "_a")
(setvar "osmode" osmode1)
)
(defun tabl_spec()
	(setq ss (ssget "_X" '((8 . "DOCLAY0"))))
	(if ss (alert "          ")(tabl_spec1))
)
(defun tabl_spec1()
   (setq olderr *error* *error* attrerr)
(setvar "cmdecho" 0)   (setvar "HIGHLIGHT" 0)
   (dellay  "DocLay0")
   (command "_LAYER" "_M" "DocLay0" "")
   (setvar "regenmode" 0)
	(sty_hi 0)
;   (setvar "REGENMODE" 1)
(setq osmode1 (getvar "osmode"))(setvar "osmode" 0)
;	(command "_style" "eskd" "gost_A.ttf" 0 0.8 15 "" "")
	(command "_zoom" "_w" '(210 0) '(3260 600))
	(setq nf 1 xt 0 yt 292 ln 0 zag nil nnf nil)
	(setq fn (open (strcat (getvar "dwgprefix") "tmp2.zvk") "r"))
	(if fn (progn
	 	(setq nstr (atoi (read-line fn)) nstr (+ nstr 1))
	(close fn)))
	(setq fn (open (strcat (getvar "dwgprefix") "tmp1.zvk") "r"))
	(if fn (progn
(vl-load-com)
(setq acadObject (vlax-get-acad-object))
(setq acadDocument (vla-get-ActiveDocument acadObject))
(setq mSpace (vla-get-ModelSpace acadDocument))
(setq 
      tbl     (vla-addtable
                (vla-get-modelspace(vla-get-activedocument (vlax-get-acad-object)))
                 (vlax-3d-point (list 20 264 0))
               (+ nstr 0) 9 
               8      ;   
                 45     ;    (,  )
                ) ;/ vla-addtable
)
(vla-DeleteRows tbl 0 1)
(vla-SetColumnWidth tbl 0 15)
(vla-SetColumnWidth tbl 1 130)
(vla-SetColumnWidth tbl 2 70)
(vla-SetColumnWidth tbl 3 40)
(vla-SetColumnWidth tbl 4 35)
(vla-SetColumnWidth tbl 5 20)
(vla-SetColumnWidth tbl 6 20)
(vla-SetColumnWidth tbl 7 20)
(vla-SetColumnWidth tbl 8 45)
	(setq nstr1 0)
	(repeat (- nstr 1)
	(setq nstr2 0)
	(repeat 9
	  (setq str1 (print(read-line fn)))
		(vla-setcellalignment tbl nstr1 nstr2 acmiddlecenter)
		(vla-setcelltextheight tbl nstr1 nstr2 2.5)
		(vla-setcelltextstyle tbl nstr1 nstr2 "ESKD")
		(vla-settext tbl nstr1 nstr2 str1)
	(setq nstr2 (1+ nstr2)))
	(setq nstr1 (1+ nstr1)))
	))(close fn)
    (vla-put-EnableBreak tbl :vlax-true)
    (vla-put-BreakSpacing tbl 25)
    (vla-put-TableBreakHeight tbl 215.0)
    (vla-put-AllowManualHeights tbl :vlax-true)
    (vla-SetBreakHeight tbl 0 205.0)
    (vla-SetBreakHeight tbl 1 245.0)
    (vla-SetBreakHeight tbl 2 245.0)
	(setq nfo (+(fix(/ (nth 0 (getvar "extmax")) 420)) 1))
	(command "_insert" "fa3n" (list 0 0) "" "" "")
	(command "_insert" "spec1" (list 0 0) "" "" "")
	(command "_insert" "shbig" (list 415 5) "" "" "")
	(if (= nfo 1)(command "_text" (list (+ xt 378 25) 21.5) 2.5 0 "1")
	  (progn
	    (command "_text" (list (+ xt 378) 21.5) 3.5 0 "1")
	    (command "_text" (list (+ xt 378 25) 21.5) 3.5 0 (itoa nfo))
	    (setq i 2 xt (+ xt 420))
	    (repeat (- nfo 1)
		(command "_insert" "spec1" (list xt 0) "" "" "")
		(command "_insert" "fa3n" (list xt 0) "" "" "")
		(command "_insert" "shlit" (list (+ xt 415) 5) "" "" "")
		(command "_text" (list (+ xt 409) 9) 3.5 0 (itoa i))
	    (setq i (1+ i) xt (+ xt 420))
	    )
	))
;(stamp)  
   (setvar "HIGHLIGHT" 1)
   (command "_LAYER" "_M" "0" "")
	(command "_zoom" "_a")
(setvar "osmode" osmode1)
)
